﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;
using Verse.AI.Group;

namespace RimWorld.BaseGen
{
    class SymbolResolver_BlackBoxMission : SymbolResolver
    {
        public override void Resolve(ResolveParams rp)
        {
            Map map = BaseGen.globalSettings.map;
            Faction faction = Faction.OfAncientsHostile;
            CellRect baseRect = rp.rect;
            BaseGen.symbolStack.Push("chargeBatteries", rp);

            ResolveParams door1 = rp;
            door1.rect = new CellRect(baseRect.minX,baseRect.minZ+17,1,1);
            door1.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door1.faction = null;
            BaseGen.symbolStack.Push("thing", door1);
            ResolveParams door2 = rp;
            door2.rect = new CellRect(baseRect.minX+17, baseRect.minZ+17, 1, 1);
            door2.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door2.faction = null;
            BaseGen.symbolStack.Push("thing", door2);
            ResolveParams door3 = rp;
            door3.rect = new CellRect(baseRect.minX+38, baseRect.minZ+17, 1, 1);
            door3.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door3.faction = null;
            BaseGen.symbolStack.Push("thing", door3);
            ResolveParams door4 = rp;
            door4.rect = new CellRect(baseRect.minX + 63, baseRect.minZ + 17, 1, 1);
            door4.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door4.faction = null;
            BaseGen.symbolStack.Push("thing", door4);
            ResolveParams door5 = rp;
            door5.rect = new CellRect(baseRect.minX + 86, baseRect.minZ + 17, 1, 1);
            door5.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door5.faction = faction;
            BaseGen.symbolStack.Push("thing", door5);
            ResolveParams door6 = rp;
            door6.rect = new CellRect(baseRect.minX + 87, baseRect.minZ + 17, 1, 1);
            door6.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door6.faction = faction;
            BaseGen.symbolStack.Push("thing", door6);
            ResolveParams door7 = rp;
            door7.rect = new CellRect(baseRect.minX + 27, baseRect.minZ + 7, 1, 1);
            door7.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door7.faction = null;
            BaseGen.symbolStack.Push("thing", door7);
            ResolveParams door8 = rp;
            door8.rect = new CellRect(baseRect.minX + 27, baseRect.minZ + 25, 1, 1);
            door8.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door8.faction = null;
            BaseGen.symbolStack.Push("thing", door8);
            ResolveParams door9 = rp;
            door9.rect = new CellRect(baseRect.minX + 50, baseRect.minZ + 7, 1, 1);
            door9.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door9.faction = null;
            BaseGen.symbolStack.Push("thing", door9);
            ResolveParams door10 = rp;
            door10.rect = new CellRect(baseRect.minX + 50, baseRect.minZ + 25, 1, 1);
            door10.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door10.faction = null;
            BaseGen.symbolStack.Push("thing", door10);
            ResolveParams door11 = rp;
            door11.rect = new CellRect(baseRect.minX + 75, baseRect.minZ + 7, 1, 1);
            door11.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door11.faction = null;
            BaseGen.symbolStack.Push("thing", door11);
            ResolveParams door12 = rp;
            door12.rect = new CellRect(baseRect.minX + 75, baseRect.minZ + 25, 1, 1);
            door12.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door12.faction = null;
            BaseGen.symbolStack.Push("thing", door12);
            ResolveParams door13 = rp;
            door13.rect = new CellRect(baseRect.minX + 12, baseRect.minZ, 1, 1);
            door13.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door13.faction = null;
            BaseGen.symbolStack.Push("thing", door13);
            ResolveParams door14 = rp;
            door14.rect = new CellRect(baseRect.minX + 12, baseRect.minZ + 32, 1, 1);
            door14.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door14.faction = null;
            BaseGen.symbolStack.Push("thing", door14);
            ResolveParams door15 = rp;
            door15.rect = new CellRect(baseRect.minX + 27, baseRect.minZ - 9, 1, 1);
            door15.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door15.faction = null;
            BaseGen.symbolStack.Push("thing", door15);
            ResolveParams door16 = rp;
            door16.rect = new CellRect(baseRect.minX + 27, baseRect.minZ + 41, 1, 1);
            door16.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door16.faction = null;
            BaseGen.symbolStack.Push("thing", door16);
            ResolveParams door17 = rp;
            door17.rect = new CellRect(baseRect.minX + 50, baseRect.minZ - 20, 1, 1);
            door17.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door17.faction = null;
            BaseGen.symbolStack.Push("thing", door17);
            ResolveParams door18 = rp;
            door18.rect = new CellRect(baseRect.minX + 50, baseRect.minZ + 52, 1, 1);
            door18.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door18.faction = null;
            BaseGen.symbolStack.Push("thing", door18);
            ResolveParams door19 = rp;
            door19.rect = new CellRect(baseRect.minX + 75, baseRect.minZ - 9, 1, 1);
            door19.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door19.faction = null;
            BaseGen.symbolStack.Push("thing", door19);
            ResolveParams door20 = rp;
            door20.rect = new CellRect(baseRect.minX + 75, baseRect.minZ + 41, 1, 1);
            door20.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door20.faction = null;
            BaseGen.symbolStack.Push("thing", door20);
            ResolveParams door21 = rp;
            door21.rect = new CellRect(baseRect.minX + 86, baseRect.minZ, 1, 1);
            door21.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door21.faction = null;
            BaseGen.symbolStack.Push("thing", door21);
            ResolveParams door22 = rp;
            door22.rect = new CellRect(baseRect.minX + 86, baseRect.minZ + 32, 1, 1);
            door22.singleThingDef = ThingDef.Named("ShipAirlockWrecked");
            door22.faction = null;
            BaseGen.symbolStack.Push("thing", door22);

            ResolveParams resolveParams = rp;
            resolveParams.rect = new CellRect(baseRect.minX-12, baseRect.minZ+2, 12, 29);
            resolveParams.faction = faction;
            BaseGen.symbolStack.Push("debrisclump", resolveParams);

            ResolveParams resolveParams1 = rp;
            resolveParams1.rect = new CellRect(baseRect.minX, baseRect.minZ, 18, 33);
            resolveParams1.faction = faction;
            resolveParams1.disableHives = true;
            BaseGen.symbolStack.Push("shipmechsandturrets", resolveParams1);
            ResolveParams resolveParams2 = rp;
            resolveParams2.rect = new CellRect(baseRect.minX, baseRect.minZ+32, 18, 18);
            resolveParams2.faction = faction;
            BaseGen.symbolStack.Push("shiptriangle2storage", resolveParams2);
            ResolveParams resolveParams3 = rp;
            resolveParams3.rect = new CellRect(baseRect.minX, baseRect.minZ, 18, 18);
            resolveParams3.faction = faction;
            resolveParams3.disableHives = true;
            BaseGen.symbolStack.Push("shiptriangle2storage", resolveParams3);

            ResolveParams resolveParams4 = rp;
            resolveParams4.rect = new CellRect(baseRect.minX+17, baseRect.minZ-9, 22, 17);
            resolveParams4.faction = faction;
            resolveParams4.disableHives = true;
            BaseGen.symbolStack.Push("shipdebriscrypto", resolveParams4);
            ResolveParams resolveParams5 = rp;
            resolveParams5.rect = new CellRect(baseRect.minX + 17, baseRect.minZ + 7, 22, 19);
            resolveParams5.faction = faction;
            resolveParams5.disableHives = true;
            BaseGen.symbolStack.Push("shipdebrisstorage", resolveParams5);
            ResolveParams resolveParams6 = rp;
            resolveParams6.rect = new CellRect(baseRect.minX + 17, baseRect.minZ + 25, 22, 17);
            resolveParams6.faction = faction;
            resolveParams6.disableHives = true;
            BaseGen.symbolStack.Push("shipdebriscrypto", resolveParams6);
            ResolveParams resolveParams7 = rp;
            resolveParams7.rect = new CellRect(baseRect.minX + 17, baseRect.minZ - 9, 22, 22);
            resolveParams7.faction = faction;
            resolveParams7.disableHives = true;
            BaseGen.symbolStack.Push("shiptriangle2storage", resolveParams7);
            ResolveParams resolveParams8 = rp;
            resolveParams8.rect = new CellRect(baseRect.minX + 17, baseRect.minZ + 41, 22, 22);
            resolveParams8.faction = faction;
            BaseGen.symbolStack.Push("shiptriangle2storage", resolveParams8);

            ResolveParams resolveParams9 = rp;
            resolveParams9.rect = new CellRect(baseRect.minX + 38, baseRect.minZ - 20, 26, 28);
            resolveParams9.faction = faction;
            resolveParams9.disableHives = true;
            BaseGen.symbolStack.Push("shipmeltdownreactor", resolveParams9);
            ResolveParams resolveParams10 = rp;
            resolveParams10.rect = new CellRect(baseRect.minX + 38, baseRect.minZ + 7, 26, 19);
            resolveParams10.faction = faction;
            resolveParams10.disableHives = true;
            BaseGen.symbolStack.Push("shipmechsandturrets", resolveParams10);
            ResolveParams resolveParams11 = rp;
            resolveParams11.rect = new CellRect(baseRect.minX + 38, baseRect.minZ + 25, 26, 28);
            resolveParams11.faction = faction;
            resolveParams11.disableHives = true;
            BaseGen.symbolStack.Push("shipmeltdownreactor", resolveParams11);
            ResolveParams resolveParams12 = rp;
            resolveParams12.rect = new CellRect(baseRect.minX + 38, baseRect.minZ - 20, 26, 26);
            resolveParams12.faction = faction;
            resolveParams12.disableHives = true;
            BaseGen.symbolStack.Push("shiptriangle2security", resolveParams12);
            ResolveParams resolveParams13 = rp;
            resolveParams13.rect = new CellRect(baseRect.minX + 38, baseRect.minZ + 52, 26, 26);
            resolveParams13.faction = faction;
            BaseGen.symbolStack.Push("shiptriangle2security", resolveParams13);

            ResolveParams resolveParams14 = rp;
            resolveParams14.rect = new CellRect(baseRect.minX + 63, baseRect.minZ - 9, 24, 17);
            resolveParams14.faction = faction;
            resolveParams14.disableHives = true;
            BaseGen.symbolStack.Push("shipdebriscannibals", resolveParams14);
            ResolveParams resolveParams15 = rp;
            resolveParams15.rect = new CellRect(baseRect.minX + 63, baseRect.minZ + 7, 24, 19);
            resolveParams15.faction = faction;
            resolveParams15.disableHives = true;
            BaseGen.symbolStack.Push("shipdebrisstorage", resolveParams15);
            ResolveParams resolveParams16 = rp;
            resolveParams16.rect = new CellRect(baseRect.minX + 63, baseRect.minZ + 25, 24, 17);
            resolveParams16.faction = faction;
            resolveParams16.disableHives = true;
            BaseGen.symbolStack.Push("shipdebriscannibals", resolveParams16);
            ResolveParams resolveParams17 = rp;
            resolveParams17.rect = new CellRect(baseRect.minX + 63, baseRect.minZ - 33, 24, 24);
            resolveParams17.faction = faction;
            resolveParams17.disableHives = true;
            BaseGen.symbolStack.Push("shiptriangle1lab", resolveParams17);
            ResolveParams resolveParams18 = rp;
            resolveParams18.rect = new CellRect(baseRect.minX + 63, baseRect.minZ + 41, 24, 24);
            resolveParams18.faction = faction;
            BaseGen.symbolStack.Push("shiptriangle1lab", resolveParams18);

            ResolveParams resolveParams18b = rp;
            resolveParams18b.rect = new CellRect(baseRect.minX + 87, baseRect.minZ + 8, 15, 17);
            resolveParams18b.faction = faction;
            resolveParams18b.disableHives = true;
            BaseGen.symbolStack.Push("shipblackbox", resolveParams18b);
            ResolveParams resolveParams19 = rp;
            resolveParams19.rect = new CellRect(baseRect.minX + 86, baseRect.minZ + 7, 17, 19);
            resolveParams19.faction = faction;
            resolveParams19.disableHives = true;
            BaseGen.symbolStack.Push("shipdebrisempty", resolveParams19);
            ResolveParams resolveParams20 = rp;
            resolveParams20.rect = new CellRect(baseRect.minX + 86, baseRect.minZ - 10, 17, 17);
            resolveParams20.faction = faction;
            resolveParams20.disableHives = true;
            BaseGen.symbolStack.Push("shiptriangle1salvage", resolveParams20);
            ResolveParams resolveParams21 = rp;
            resolveParams21.rect = new CellRect(baseRect.minX + 86, baseRect.minZ + 25, 17, 17);
            resolveParams21.faction = faction;
            BaseGen.symbolStack.Push("shiptriangle1salvage", resolveParams21);
        }
    }
}
